"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var g = require("window-or-global");
var yup_1 = require("yup");
require("reflect-metadata");
var isSchema = function (schema) { return 'validate' in schema; };
exports.paramMetadataKey = g.ConvectorParamMetadataKey || Symbol('param');
g.ConvectorParamMetadataKey = exports.paramMetadataKey;
function Param(model, opts) {
    if (opts === void 0) { opts = { context: {} }; }
    return function (target, propertyKey, parameterIndex) {
        var schemas = Reflect.getOwnMetadata(exports.paramMetadataKey, target, propertyKey) || [];
        var schema = isSchema(model) ? model : yup_1.object()
            .transform(function (value) { return value instanceof model ? value : new model(value); });
        schemas[parameterIndex] = [schema, opts, !isSchema(model) && model];
        Reflect.defineMetadata(exports.paramMetadataKey, schemas, target, propertyKey);
    };
}
exports.Param = Param;
//# sourceMappingURL=param.decorator.js.map